<?php

    class Set_Context_Variable_Action extends Reactor_Action
    {
        protected $tpl = 'set_context_variable.php';
        protected $name = 'Set context variable';
		
		public static $registration = array(
			ACTION_NAME => 'Set a context variable',
			ACTION_CATEGORY => 'Nagios Reactor',
			ACTION_DESCRIPTION => 'Updates the value of an event chain context variable during runtime.',
			ACTION_AUTHOR => 'Jeremy Yunis, Nagios Enterprises, LLC',
			ACTION_VERSION => '1.0',
			ACTION_DATE => '01/22/2013', //Last version update
			ACTION_AUTHLEVEL => 0,  // 0 - everyone | 1 - Admin only
			ACTION_TYPE => 'core', //core | user. core modules can't be deleted
			ACTION_META => array(),	//Misc information	
		); 
		
        protected $fields = array(
            'varname' => array(
                'label' => 'variable name',
                'validate' => 'trim|required|alpha_dash|xss_clean|prep_for_form',
            ),
            'value' => array(
                'label' => 'value',
                'validate' => 'trim|required|xss_clean|prep_for_form',
            ),
        );

        public function get_label()
        {
            if($params = $this->get_params()) {
                if(array_key_exists('varname', $params) &&
                        array_key_exists('value', $params)) {
                    return sprintf('Set context variable \'%s\' to \'%s\'', $params['varname'], $params['value']);
                }
            }
            return parent::get_label();
        }
       
        public function run($context)
        {
            $this->set_context($context);
            $params = $this->get_params();
            if(array_key_exists('varname', $params) &&
                array_key_exists('value', $params)) {
                    $context[$params['varname']] = $params['value'];
            }
            $this->set_result(0);
            return $context;
        }
    }
